Codeforces Round #256 (Div. 2) C. Painting Fence 搜索或DP

C. Painting Fence
time limit per test
1 second
memory limit per test
512 megabytes
input
standard input
output
standard output

Bizon the Champion isn't just attentive, he also is very hardworking.

Bizon the Champion decided to paint his old fence his favorite color, orange. The fence is represented as n vertical planks, put in a row. Adjacent planks have no gap between them. The planks are numbered from the left to the right starting from one, the i-th plank has the width of 1 meter and the height of ai meters.

Bizon the Champion bought a brush in the shop, the brush's width is 1 meter. He can make vertical and horizontal strokes with the brush. During a stroke the brush's full surface must touch the fence at all the time (see the samples for the better understanding). What minimum number of strokes should Bizon the Champion do to fully paint the fence? Note that you are allowed to paint the same area of the fence multiple times.

Input

The first line contains integer n (1 ≤ n ≤ 5000) — the number of fence planks. The second line contains n space-separated integersa1, a2, ..., an (1 ≤ ai ≤ 109).

Output

Print a single integer — the minimum number of strokes needed to paint the whole fence.

Sample test(s)
input
5
2 2 1 2 1
output
3
input
2
2 2
output
2
input
1
5
output
1
Note

In the first sample you need to paint the fence in three strokes with the brush: the first stroke goes on height 1 horizontally along all the planks. The second stroke goes on height 2 horizontally and paints the first and second planks and the third stroke (it can be horizontal and vertical) finishes painting the fourth plank.

In the second sample you can paint the fence with two strokes, either two horizontal or two vertical strokes.

In the third sample there is only one plank that can be painted using a single vertical stroke.


题意:你面前有宽度为1,高度给定的连续木板,每次可以刷一横排或一竖列,问你至少需要刷几次。

解题方法一:DP

思路:这题刚开始看题的时候知道,不是取n,就是取其中最短的然后横着刷,然后再取最短的再横着刷,再和坚着刷比较哪个更小。但是知道了不知道该如何下手。然后发现别人是动态规划做的。看了好久的状态方程才有点理解。

dp[i][j]表示第i列以后的木板都刷完了且前面的第j列是横着刷的,最少需要的次数。

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<map>
#include<queue>
#include<set>
#include<cmath>
#include<bitset>
#define mem(a,b) memset(a,b,sizeof(a))
#define INF 1000000070000
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
int value[5010],dp[5010][5010];
int main()
{
    int n,i,j,k;
    scanf("%d",&n);
    value[0]=0;
    for(i=1; i<=n; i++)
        scanf("%d",&value[i]);
    for(i=0; i<=n; i++)
        dp[n][i]=0;
    for(i=n; i>=1; i--)
        for(j=0; j<i; j++)
        {
            if(value[j]>=value[i])
                dp[i-1][j]=dp[i][i];
            else dp[i-1][j]=min(dp[i][j]+1,dp[i][i]+value[i]-value[j]);
            //cout<<i<<' '<<j<<' '<<dp[i-1][j]<<endl;
        }
    printf("%d\n",dp[0][0]);
}

解题方法二:搜索

思路:如果是竖着刷,应当是篱笆的条数,横着刷的话,就是刷完最短木板的长度,再接着考虑没有刷的木板中最短的。然后再和坚着刷比较。这样可以用搜索来找每次最短的。

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<map>
#include<queue>
#include<set>
#include<cmath>
#include<bitset>
#define mem(a,b) memset(a,b,sizeof(a))
#define INF 100000007
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
int a[5005];
int dfs(int l,int r)
{
    int i,ll,num=0,Min=INF;
    for(i=l;i<=r;i++)
        Min=min(Min,a[i]);
    for(i=l;i<=r;i++)
        a[i]-=Min;
    num+=Min;
    for(i=l,ll=l;i<=r;i++)
        if(!a[i]) num+=dfs(ll,i-1),ll=i+1;
    if(ll<=r) num+=dfs(ll,r);
    return min(num,r-l+1);
}
int main()
{
    int n,i;
    cin>>n;
    for(i=1;i<=n;i++)
        scanf("%d",a+i);
    cout<<dfs(1,n)<<endl;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值